 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */




SET(BBTK_PACKAGE_LIB_PATH ${CMAKE_CREA_LIB_PATH} )

IF(WIN32)
  SET (EXECUTABLE_OUTPUT_REL_PATH "") 
  SET (LIBRARY_OUTPUT_REL_PATH    "")
#  FILE(TO_NATIVE_PATH  ${PROJECT_BINARY_DIR}/$(OutDir)  BBTK_BIN_PATH)
#  SET(BBTK_BIN_PATH ${BBTK_DIR}/bin})
#  FIND_FILE(PATHS ${BBTK_BIN_PATH})

  FIND_PATH(BBTK_BIN_PATH bbi.exe ${BBTK_DIR}/bin ${BBTK_DIR}/Release ${BBTK_DIR}/RelWithDebInfo ${BBTK_DIR}/Debug NO_DEFAULT_PATH)

  IF(NOT BBTK_BIN_PATH)
    MESSAGE(FATAL_ERROR "bbi not found in ${BBTK_DIR}/bin ; ${BBTK_DIR}/Release ; ${BBTK_DIR}/Debug ; ${BBTK_DIR}/RelWithDebInfo : is bbtk properly built ?")
  ENDIF(NOT BBTK_BIN_PATH)

##  SET (ADDITIONAL_DLL_PATH "C:/Program Files/CreaTools/crea_ThirdParty_dlls-0.2.0/bin" CACHE PATH "Additional paths in which to look for dlls")

  SET(BBTK_BBI "${BBTK_BIN_PATH}/bbi")
  SET(BBTK_BBS2CPP "${BBTK_BIN_PATH}/bbs2cpp")
  SET(BBTK_BBC "${BBTK_BIN_PATH}/bbc")
  SET(BBTK_BBFY "${BBTK_BIN_PATH}/bbfy")
  SET(BBTK_BBPCONFIGURATOR "${BBTK_BIN_PATH}/bbpConfigurator")
  SET(BBTK_BBDOC "${BBTK_BIN_PATH}/bbdoc")
ELSE(WIN32)
#  SET (EXECUTABLE_OUTPUT_REL_PATH bin) 
#  SET (LIBRARY_OUTPUT_REL_PATH    bin)
  SET(BBTK_BIN_PATH ${BBTK_INSTALL_PREFIX}/bin)
  SET(BBTK_BBI "${BBTK_BIN_PATH}/bbi")
  SET(BBTK_BBS2CPP "${BBTK_BIN_PATH}/bbs2cpp")
  SET(BBTK_BBC "${BBTK_BIN_PATH}/bbc")
  SET(BBTK_BBFY "${BBTK_BIN_PATH}/bbfy")
  SET(BBTK_BBPCONFIGURATOR "${BBTK_BIN_PATH}/bbpConfigurator")
  SET(BBTK_BBDOC "${BBTK_BIN_PATH}/bbdoc")  
ENDIF(WIN32)


INCLUDE(${BBTK_CMAKE_DIR}/BBTKSetDeducedPaths.cmake)

